org.richfaces.json

## Class JSONWriter

- java.lang.Object
- - org.richfaces.json.JSONWriter

- Direct Known Subclasses:
    JSONStringer

      public class JSONWriter
      extends Object

  JSONWriter provides a quick and convenient way of producing JSON text. The texts produced strictly conform to JSON syntax rules. No whitespace is added, so the results are ready for transmission or storage. Each instance of JSONWriter can produce one JSON text.

  A JSONWriter instance provides a `value` method for appending values to the text, and a `key` method for adding keys before values in objects. There are `array` and `endArray` methods that make and bound array values, and `object` and `endObject` methods which make and bound object values. All of these methods return the JSONWriter instance, permitting a cascade style. For example,

       new JSONWriter(myWriter).object().key("JSON").value("Hello, World!").endObject();

  which writes

       {"JSON":"Hello, World!"}

  The first method called must be `array` or `object`. There are no methods for adding commas or colons. JSONWriter adds them for you. Objects and arrays can be nested up to 20 levels deep.

  This can sometimes be easier than using a JSONObject to build a string.
  Version:
    2
  Author:
    JSON.org

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected char` | `mode` The current mode.
    `protected Writer` | `writer` The writer that will receive the output.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JSONWriter(Writer w)` Make a fresh JSONWriter.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `JSONWriter` | `array()` Begin appending a new array.
    `JSONWriter` | `endArray()` End an array.
    `JSONWriter` | `endObject()` End an object.
    `JSONWriter` | `key(String s)` Append a key.
    `JSONWriter` | `object()` Begin appending a new object.
    `JSONWriter` | `value(boolean b)` Append either the value `true` or the value `false`.
    `JSONWriter` | `value(double d)` Append a double value.
    `JSONWriter` | `value(long l)` Append a long value.
    `JSONWriter` | `value(Object o)` Append an object value.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### mode

          protected char mode

      The current mode. Values: 'a' (array), 'd' (done), 'i' (initial), 'k' (key), 'o' (object).

    - #### writer

          protected Writer writer

      The writer that will receive the output.

  - ### Constructor Detail

    - #### JSONWriter

          public JSONWriter(Writer w)

      Make a fresh JSONWriter. It can be used to build one JSON text.

  - ### Method Detail

    - #### array

          public JSONWriter array()
                           throws JSONException

      Begin appending a new array. All values until the balancing `endArray` will be appended to this array. The `endArray` method must be called to mark the array's end.
      Returns:
        this
      Throws:
        `JSONException` - If the nesting is too deep, or if the object is started in the wrong place (for example as a key or after the end of the outermost array or object).

    - #### endArray

          public JSONWriter endArray()
                              throws JSONException

      End an array. This method most be called to balance calls to `array`.
      Returns:
        this
      Throws:
        `JSONException` - If incorrectly nested.

    - #### endObject

          public JSONWriter endObject()
                               throws JSONException

      End an object. This method most be called to balance calls to `object`.
      Returns:
        this
      Throws:
        `JSONException` - If incorrectly nested.

    - #### key

          public JSONWriter key(String s)
                         throws JSONException

      Append a key. The key will be associated with the next value. In an object, every value must be preceded by a key.
      Parameters:
        `s` - A key string.
      Returns:
        this
      Throws:
        `JSONException` - If the key is out of place. For example, keys do not belong in arrays or if the key is null.

    - #### object

          public JSONWriter object()
                            throws JSONException

      Begin appending a new object. All keys and values until the balancing `endObject` will be appended to this object. The `endObject` method must be called to mark the object's end.
      Returns:
        this
      Throws:
        `JSONException` - If the nesting is too deep, or if the object is started in the wrong place (for example as a key or after the end of the outermost array or object).

    - #### value

          public JSONWriter value(boolean b)
                           throws JSONException

      Append either the value `true` or the value `false`.
      Parameters:
        `b` - A boolean.
      Returns:
        this
      Throws:
        `JSONException`

    - #### value

          public JSONWriter value(double d)
                           throws JSONException

      Append a double value.
      Parameters:
        `d` - A double.
      Returns:
        this
      Throws:
        `JSONException` - If the number is not finite.

    - #### value

          public JSONWriter value(long l)
                           throws JSONException

      Append a long value.
      Parameters:
        `l` - A long.
      Returns:
        this
      Throws:
        `JSONException`

    - #### value

          public JSONWriter value(Object o)
                           throws JSONException

      Append an object value.
      Parameters:
        `o` - The object to append. It can be null, or a Boolean, Number, String, JSONObject, or JSONArray, or an object with a toJSONString() method.
      Returns:
        this
      Throws:
        `JSONException` - If the value is out of sequence.

Copyright © 2015 JBoss by Red Hat. All Rights Reserved.